<html>
<head>
<title>Exemplo: Populando selects de cidades e estados com AJAX (PHP e jQuery) | DaviFerreira blog!</title>
<style type="text/css">
*, html {
	font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
	margin: 0px;
	padding: 0px;
	font-size: 12px;
}
a {
	color: #0099CC;
}
body {
	margin: 10px;
}
.carregando {
	color:#666;
	display:none;
}
</style>
</head>
<body>
<?php
require("conn.open.php");

function listaEstadosOrderIdAsc(){
	return mysql_query("SELECT cod_estados, sigla FROM estados ORDER BY sigla ASC");
}
?>
<p>
  <label for="cod_estados">Estado:</label>
  <select name="cod_estados" id="cod_estados">
    <option value="">(selecione aqui)</option>
    <?php $estados = listaEstadosOrderIdAsc(); while ($row = mysql_fetch_object($estados)) { ?>
    <option value="<?php echo $row->cod_estados; ?>"><?php echo $row->sigla; ?></option>
    <?php } ?>
  </select>
  <label for="cod_cidades">Cidade:</label>
  <select name="cod_cidades" id="cod_cidades">
    <option value="">-- Escolha um estado --</option>
  </select>
</p>
<p>&nbsp;</p>
<p>
  <label for="estados">Estado:</label>
  <select name="estados" id="estados">
    <option value="">(selecione aqui)</option>
    <?php $estados = listaEstadosOrderIdAsc(); while ($row = mysql_fetch_object($estados)) { ?>
    <option value="<?php echo $row->cod_estados; ?>"><?php echo $row->sigla; ?></option>
    <?php } ?>
  </select>
  <label for="cidades">Cidade:</label>
  <select name="cidades" id="cidades">
    <option value="">-- Escolha um estado --</option>
  </select>
</p>
<p>&nbsp;</p>
<p>
  <label for="cod_estado">Estado:</label>
  <select name="cod_estado" id="cod_estado">
    <option value="">(selecione aqui)</option>
    <?php $estados = listaEstadosOrderIdAsc(); while ($row = mysql_fetch_object($estados)) { ?>
    <option value="<?php echo $row->cod_estados; ?>"><?php echo $row->sigla; ?></option>
    <?php } ?>
  </select>
  <label for="cod_cidade">Cidade:</label>
  <select name="cod_cidade" id="cod_cidade">
    <option value="">-- Escolha um estado --</option>
  </select>
</p>
<script src="http://www.google.com/jsapi"></script>
<script type="text/javascript">
		  google.load('jquery', '1.3');
		</script>
<script type="text/javascript">

$(document).ready(function(){

	// Por Rogerio Coli, www.rcoli.com.br - favor não remover
	jQuery.fn.carregaCidades = function() {
		
		// Objeto que guarda os argumentos
		var args 					= arguments[0] || {};
		
		//id do Select de Cidades
		var idSelectCidade 			= args.idSelectCidade;
		
		// Página que irá criar o JSon
		var paginaPhpCidades		= 'cidades.ajax.php';
		
		// Conteúdo do elemento span que vai aparecer enquanto carregam as cidades, 
		// pode ser substituído por uma imagem. Coloque a tag completa	
		var carregandoMsg			= 'Aguarde, carregando...' 	
		
		// Classe do elemento span que vai aparecer enquanto carregam as cidades
		var carregandoClass			= 'class';
		// após as cidades carregarem aparece esta mensagem
		var jsonPrimeiroElemento 	= '(selecione a cidade)';
		// Aqui eu pego a frase do primeiro option de Cidade  
		var primeiroElemento		= $(idSelectCidade).find('option:first').html();
		
		
		if( $(this).val() ) {
			// escondendo as cidades até carregarem
			$(idSelectCidade).hide();
			// mensagem de espera: carregando
			$(idSelectCidade).after('<span class='+ carregandoClass +'>'+carregandoMsg+'</span>');
			
			$.getJSON(paginaPhpCidades+'?search=',{cod_estados: $(this).val(), ajax: 'true'}, function(j){
					// É importante que o value seja vazio pra que o formulário não seja enviado vazio
					// caso use o form validate
				var options = '<option value="">'+jsonPrimeiroElemento+'</option>';    
				for (var i = 0; i < j.length; i++) {
					// É importante que o value seja vazio pra que o formulário não seja enviado vazio
					// caso use o form validate
					options += '<option value="' + j[i].cod_cidades + '">' + j[i].nome + '</option>';
				} 
				// mostrando as cidades após carregarem e removendo a mensagem de espera
				$(idSelectCidade).html(options).show();
				$(idSelectCidade).next().remove();
			});
		} else {
			$(idSelectCidade).html('<option value="">'+primeiroElemento+'</option>');
		}
		
	};
	//Inciando o SELECT, importante ao recarregar a página
	$("#cod_estados option:first").attr('selected','selected');
	// Aqui eu chamo a função e o método que irá carregá-la
	$('#cod_estados').change(function(){ $(this).carregaCidades({idSelectCidade: '#cod_cidades'}); })
});
</script>
</body>
</htm>
